searchNodes=[{"doc":"Creation of module aliases","ref":"alias.html","title":"alias","type":"module"},{"doc":"Create a module Alias for the given OrigMod module. This function is useful for creating in-memory Elixir wrapper modules without needing to maintain persistent files with such wrappers. IncFuns argument can be all or a list of {Fun, Arity} values which only export a subset of functions from the OrigMod .","ref":"alias.html#create/2","title":"alias.create/2","type":"function"},{"doc":"","ref":"alias.html#create/3","title":"alias.create/3","type":"function"},{"doc":"","ref":"base32.html","title":"base32","type":"module"},{"doc":"","ref":"base32.html#decode/1","title":"base32.decode/1","type":"function"},{"doc":"","ref":"base32.html#decode/2","title":"base32.decode/2","type":"function"},{"doc":"","ref":"base32.html#encode/1","title":"base32.encode/1","type":"function"},{"doc":"","ref":"base32.html#encode/2","title":"base32.encode/2","type":"function"},{"doc":"","ref":"cipher.html","title":"cipher","type":"module"},{"doc":"","ref":"cipher.html#decrypt/2","title":"cipher.decrypt/2","type":"function"},{"doc":"","ref":"cipher.html#decrypt_base64/2","title":"cipher.decrypt_base64/2","type":"function"},{"doc":"","ref":"cipher.html#encrypt/2","title":"cipher.encrypt/2","type":"function"},{"doc":"","ref":"cipher.html#encrypt_base64/2","title":"cipher.encrypt_base64/2","type":"function"},{"doc":"Decode PGP public key","ref":"cipher.html#gpg_key_decode/1","title":"cipher.gpg_key_decode/1","type":"function"},{"doc":"","ref":"cipher.html#make_key/1","title":"cipher.make_key/1","type":"function"},{"doc":"","ref":"cipher.html#make_key_base64/1","title":"cipher.make_key_base64/1","type":"function"},{"doc":"CSV file parsing functions","ref":"csv.html","title":"csv","type":"module"},{"doc":"Guess the type of data by its value","ref":"csv.html#guess_data_type/1","title":"csv.guess_data_type/1","type":"function"},{"doc":"Guess data types of fields in the given CSV list of rows obtained by parsing a CSV file with parse(File,[fix_lengths]) . The function returns a list of tuples {Type, MaxFieldLen, NumOfNulls} , where the Type is a field type, MaxFieldLen is the max length of data in this column, and NumOfNulls is the number of rows with empty values in this column.","ref":"csv.html#guess_data_types/2","title":"csv.guess_data_types/2","type":"function"},{"doc":"Load CSV data from a File to a MySQL database. Tab is the name of a table where to load data. MySqlPid is the pid of a MySQL database connection returned by mysql:start_link/1 . The data in the table is replaced according to {import_type, Type} : recreate - The table is entirely replaced with the data from file. The data from the file is loaded atomically - i.e. either the whole file loading succeeds or fails. This is accomplished by first loading data to a temporary table, and then using the database's ACID properties to replace the target table with the temporary table. replace - Use &quot;REPLACE INTO&quot; instead of &quot;INSERT INTO&quot; existing table ignore_dups - The insert in the existing table is performed and the records with duplicate keys are ignored update_dups - The insert in the existing table is performed and the records with duplicate keys are updated upsert - The insert/update in the existing table is performed without creating a temporary table NOTE: this function requires https://github.com/mysql-otp/mysql-otp.git","ref":"csv.html#load_to_mysql/4","title":"csv.load_to_mysql/4","type":"function"},{"doc":"Get max field lengths for a list obtained by parsing a CSV file with parse_csv_file(File,[fix_lengths]) .","ref":"csv.html#max_field_lengths/2","title":"csv.max_field_lengths/2","type":"function"},{"doc":"Parse a CSV file using default options.","ref":"csv.html#parse/1","title":"csv.parse/1","type":"function"},{"doc":"Parse a given CSV file.","ref":"csv.html#parse/2","title":"csv.parse/2","type":"function"},{"doc":"Parse a CSV line","ref":"csv.html#parse_line/1","title":"csv.parse_line/1","type":"function"},{"doc":"Options for loading data to a database. {load_type, Type} Type of loading to perform. recreate will replace the table by atomically dropping the old one, creating/loading the new one, and replacing the table. replace will do an insert by using REPLACE INTO statement. ignore_dups will use INSERT IGNORE INTO statement to ignore records with duplicate keys. update_dups will do an INSERT INTO and ON DUPLICATE KEY UPDATE , so that the old records are updated and the new ones are inserted. {create_table, Allow} Allow to create a table if it doesn't exist {col_types, Map} Types of data for all or some columens. The Map is in the format: ColName::binary() =&gt; ColInfo , where ColInfo is ColType | {ColType, ColLen::integer()} , and ColType is: date | datetime | integer | float | blob | number . {transforms, Map} Value transformation function for columns. The Map is in the format: ColName::binary() =&gt; fun((Value::term()) -&gt; term()) . {batch_size, Size} Number of records per SQL insert/update/replace call {blob_size, Size} Threshold in number of bytes at which a VARCHAR field is defined as BLOB {save_create_sql_to_file, Filename::string()} Save CREATE TABLE sql statement to a file guess_types When specified, the function will try to guess the type of data in columns instead of treating all data as string fields. The possible data typed guessed: integer, float, date, datetime, number, string {guess_limit_rows, Limit} Limit the number of rows for guessing the column data types {max_nulls_pcnt, Percent} A percentage threshold of permissible NULLs in a column (0-100), above which the column data type is forced to be treated as string {primary_key, Fields} Names of primary key fields in the created table {drop_temp_table, boolean()} When true (default), temp table is dropped. {encoding, Encoding} The name of the encoding to use for storing data. For the list of permissible values [see this link](https://dev.mysql.com/doc/refman/8.0/en/charset-unicode-sets.html) verbose Print additional details to stdout","ref":"csv.html#t:load_options/0","title":"csv.load_options/0","type":"type"},{"doc":"CSV Parsing Options. fix_lengths if a record has a column count greater than what's found in the header row, those extra columns will be dropped, and if a row has fewer columns, empty columns will be added. binary Return fields as binaries (default) list Return fields as lists {open, list()} Options given to file:open/2 {columns, Names} Return data only in given columns {converters, [{Col, fun((ColName, Value) -&gt; NewValue)| {rex, RegEx, Replace}]} Data format converter. If Col is all , the same converting function is used for all columns. If the converter is a {rex, RegEx, Replace} then the regular expression replacement will be run on a value in the requested column.","ref":"csv.html#t:parse_options/0","title":"csv.parse_options/0","type":"type"},{"doc":"Module and function decompiler","ref":"decompiler.html","title":"decompiler","type":"module"},{"doc":"Decompile a function to its source text","ref":"decompiler.html#fun_src/1","title":"decompiler.fun_src/1","type":"function"},{"doc":"Decompile a function to its source text","ref":"decompiler.html#fun_src/2","title":"decompiler.fun_src/2","type":"function"},{"doc":"Decompile a beam file","ref":"decompiler.html#run/1","title":"decompiler.run/1","type":"function"},{"doc":"Decompile a beam file and optionally save it to disk","ref":"decompiler.html#run/2","title":"decompiler.run/2","type":"function"},{"doc":"Environment utils","ref":"env.html","title":"env","type":"module"},{"doc":"Get application configuration","ref":"env.html#get_env/3","title":"env.get_env/3","type":"function"},{"doc":"","ref":"env.html#home_dir/0","title":"env.home_dir/0","type":"function"},{"doc":"","ref":"env.html#normalize_path/1","title":"env.normalize_path/1","type":"function"},{"doc":"Perform replacement of environment variable values in the OsPath. Example : env : replace_env_vars ( &quot;~/app&quot; ) -&gt; &quot;/home/cuser/app&quot; env : replace_env_vars ( &quot;${HOME}/app&quot; ) -&gt; &quot;/home/cuser/app&quot; env : replace_env_vars ( &quot;$USER/app&quot; ) -&gt; &quot;cuser/app&quot; See also: os:getenv/1 .","ref":"env.html#replace_env_vars/1","title":"env.replace_env_vars/1","type":"function"},{"doc":"Perform replacement of environment variable values in the OsPath. This function also allows to provide a list of Bindings that override the environment (they are checked before environment variables are looked up). Example : env : replace_env_vars ( &quot;~/&quot; , [ { &quot;HOME&quot; , &quot;/home/cu&quot; } ] ) -&gt; &quot;/home/cu/&quot; env : replace_env_vars ( &quot;~/&quot; , [ { home , &quot;/home/cu&quot; } ] ) -&gt; &quot;/home/cu/&quot; env : replace_env_vars ( &quot;$A/&quot; , [ { a , &quot;/aaa&quot; } ] ) -&gt; &quot;/aaa/&quot; env : replace_env_vars ( &quot;${A}/&quot; , [ { a , &quot;/aaa&quot; } ] ) -&gt; &quot;/aaa/&quot; See also: os:getenv/1 .","ref":"env.html#replace_env_vars/2","title":"env.replace_env_vars/2","type":"function"},{"doc":"","ref":"env.html#subst_env_path/1","title":"env.subst_env_path/1","type":"function"},{"doc":"","ref":"env.html#subst_env_path/2","title":"env.subst_env_path/2","type":"function"},{"doc":"","ref":"erlang_scan.html","title":"erlang_scan","type":"module"},{"doc":"","ref":"erlang_scan.html#format_error/1","title":"erlang_scan.format_error/1","type":"function"},{"doc":"","ref":"erlang_scan.html#reserved_word/1","title":"erlang_scan.reserved_word/1","type":"function"},{"doc":"","ref":"erlang_scan.html#string/1","title":"erlang_scan.string/1","type":"function"},{"doc":"","ref":"erlang_scan.html#string/2","title":"erlang_scan.string/2","type":"function"},{"doc":"","ref":"erlang_scan.html#token/2","title":"erlang_scan.token/2","type":"function"},{"doc":"","ref":"erlang_scan.html#token/3","title":"erlang_scan.token/3","type":"function"},{"doc":"","ref":"erlang_scan.html#tokens/2","title":"erlang_scan.tokens/2","type":"function"},{"doc":"","ref":"erlang_scan.html#tokens/3","title":"erlang_scan.tokens/3","type":"function"},{"doc":"Periodically read an append-only log file and parse newly added data. The user controls the interval in msec how often to check for file modifications. When new data is appended to file it triggers invocation of the user-defined parsing function that deliminates the file, and the result is delivered to the consumer by calling the consumer callback function. The log reader can be started as a gen_server or can be controlled synchronously by using init/3 , run/1 , and close/1 methods.","ref":"file_log_reader.html","title":"file_log_reader","type":"module"},{"doc":"Close file processor (use this method when not using gen_server)","ref":"file_log_reader.html#close/1","title":"file_log_reader.close/1","type":"function"},{"doc":"When using file processor without gen_server, use this function to initialize the state, and then call run/1.","ref":"file_log_reader.html#init/3","title":"file_log_reader.init/3","type":"function"},{"doc":"Report last processed file position/size.","ref":"file_log_reader.html#position/1","title":"file_log_reader.position/1","type":"function"},{"doc":"Return current parser state ( {pstate, any()} initialization option).","ref":"file_log_reader.html#pstate/1","title":"file_log_reader.pstate/1","type":"function"},{"doc":"Process file from given position Pos to EndPos (or eof ).","ref":"file_log_reader.html#run/1","title":"file_log_reader.run/1","type":"function"},{"doc":"","ref":"file_log_reader.html#start/3","title":"file_log_reader.start/3","type":"function"},{"doc":"Start the server outside of supervision tree.","ref":"file_log_reader.html#start/4","title":"file_log_reader.start/4","type":"function"},{"doc":"Process File by calling Consumer callback on every delimited message. Message delimination is handled by the {parser, Parser} option. Consumer function gets called iteratively with the following arguments: (Msg, Pos::integer(), State) Msg is what the parser function returned. Pos is current file position following the Msg . State is current value of parser state that is initialized by {pstate, PState} option given to the start_link/{3,4} function ({'$end_of_file', Filename::string(), Result}, Pos::integer(), PState) This call happens when end of file condition is reached (see definition of consumer() type) Consumer can end processing normally without reaching the end of file by throwing {eof, PState} exception.","ref":"file_log_reader.html#start_link/3","title":"file_log_reader.start_link/3","type":"function"},{"doc":"To be called by the supervisor in order to start the server. If init/1 fails with Reason, the function returns {error,Reason} . If init/1 returns {stop,Reason} or ignore, the process is terminated and the function returns {error,Reason} or ignore, respectively. See also: start_link/3 .","ref":"file_log_reader.html#start_link/4","title":"file_log_reader.start_link/4","type":"function"},{"doc":"Stop the server.","ref":"file_log_reader.html#stop/1","title":"file_log_reader.stop/1","type":"function"},{"doc":"Update parser state.","ref":"file_log_reader.html#update_pstate/3","title":"file_log_reader.update_pstate/3","type":"function"},{"doc":"","ref":"file_log_reader.html#t:consumer/0","title":"file_log_reader.consumer/0","type":"type"},{"doc":"Details: pos Start reading from this position (default: 0) end_pos Read until this position and stop. If provided and file position reaches end_pos , the consumer() callback given to the reader will be called as: Consumer({'$end_of_file', Filename::string(), Result}, Pos::integer(), State) where Result is ok or {error|exit|exception, Error::any(), StackTrace} if an error occured. max_size Maximum chunk size to read from file in a single pass (default: 32M). timeout Number of milliseconds between successive file scanning (default: 1000) retry_sec Number of seconds between successive retries upon failure to open the market data file passed to one of the start*/{3,4} functions (default: 15). The value of 0 means that the file must exist or else the process won't start. parser Is the function to be called when the next chunk is read from file. The function must return: {ok, Msg, Tail, State} invoke Consumer callback passing it the parsed message Msg , and continue parsing the Tail binary {incomplete, State} the data contains no complete messages - wait until there's more {skip, Tail, State} disregard input and continue parsing Tail without calling Consumer callback pstate Initial value of the parser state or a functor fun((File::string() Consumer::consumer(), Options::options()) -&gt; PState::any()) pstate_update Update function of the parser state. Called when the user invokes update_pstate/3","ref":"file_log_reader.html#t:options/0","title":"file_log_reader.options/0","type":"type"},{"doc":"Leader election behavior. This application implements a leader election behavior modeled after gen_server. This behavior intends to make it reasonably straightforward to implement a fully distributed server with master-slave semantics. The gen_leader behavior supports nearly everything that gen_server does (some functions, such as multicall() and the internal timeout, have been removed), and adds a few callbacks and API functions to support leader election etc. Also included is an example program, a global dictionary, based on the modules gen_leader and dict. The callback implementing the global dictionary is called 'test_cb', for no particularly logical reason. New version: The internal leader election algorithm was faulty and has been replaced with a new version based on a different leader election algorithm. As a consequence of this the query functions alive and down can no longer be provided. The new algorithm also make use of an incarnation parameter, by default written to disk in the function incarnation. This implies that only one gen_leader per node is permitted, if used in a diskless environment, incarnation must be adapted. Modifications contributed by Serge Aleynikov: Added configurable startup options (see leader_options() type) Implemented handle_DOWN/3 callback with propagation of the leader's state via broadcast to all connected candidates. Fixed population of the #election.down member so that down/1 query can be used in the behavior's implementation Rewrote implementation of the tau timer to prevent the leader looping on the timer timeout event when all candidates are connected.","ref":"gen_leader.html","title":"gen_leader","type":"behaviour"},{"doc":"Returns list of alive nodes.","ref":"gen_leader.html#alive/1","title":"gen_leader.alive/1","type":"function"},{"doc":"","ref":"gen_leader.html#behaviour_info/1","title":"gen_leader.behaviour_info/1","type":"function"},{"doc":"","ref":"gen_leader.html#broadcast/3","title":"gen_leader.broadcast/3","type":"function"},{"doc":"Equivalent to gen_server:call/2 , but with a slightly different exit reason if something goes wrong. This function calls the gen_leader process exactly as if it were a gen_server (which, for practical purposes, it is.)","ref":"gen_leader.html#call/2","title":"gen_leader.call/2","type":"function"},{"doc":"Equivalent to gen_server:call/3 , but with a slightly different exit reason if something goes wrong. This function calls the gen_leader process exactly as if it were a gen_server (which, for practical purposes, it is.)","ref":"gen_leader.html#call/3","title":"gen_leader.call/3","type":"function"},{"doc":"Returns a list of known candidates.","ref":"gen_leader.html#candidates/1","title":"gen_leader.candidates/1","type":"function"},{"doc":"Equivalent to gen_server:cast / 2.","ref":"gen_leader.html#cast/2","title":"gen_leader.cast/2","type":"function"},{"doc":"Returns list of down nodes.","ref":"gen_leader.html#down/1","title":"gen_leader.down/1","type":"function"},{"doc":"","ref":"gen_leader.html#format_status/2","title":"gen_leader.format_status/2","type":"function"},{"doc":"","ref":"gen_leader.html#init_it/6","title":"gen_leader.init_it/6","type":"function"},{"doc":"Makes a call (similar to gen_server:call/2 ) to the leader. The call is forwarded via the local gen_leader instance, if that one isn't actually the leader. The client will exit if the leader dies while the request is outstanding. This function uses gen:call/3 , and is subject to the same default timeout as e.g. gen_server:call/2 .","ref":"gen_leader.html#leader_call/2","title":"gen_leader.leader_call/2","type":"function"},{"doc":"Makes a call (similar to gen_server:call/3 ) to the leader. The call is forwarded via the local gen_leader instance, if that one isn't actually the leader. The client will exit if the leader dies while the request is outstanding.","ref":"gen_leader.html#leader_call/3","title":"gen_leader.leader_call/3","type":"function"},{"doc":"Similar to gen_server:cast/2 but will be forwarded to the leader via the local gen_leader instance.","ref":"gen_leader.html#leader_cast/2","title":"gen_leader.leader_cast/2","type":"function"},{"doc":"Returns the current leader node.","ref":"gen_leader.html#leader_node/1","title":"gen_leader.leader_node/1","type":"function"},{"doc":"","ref":"gen_leader.html#print_event/3","title":"gen_leader.print_event/3","type":"function"},{"doc":"Equivalent to gen_server:reply / 2.","ref":"gen_leader.html#reply/2","title":"gen_leader.reply/2","type":"function"},{"doc":"Starts a gen_leader process without linking to the parent. See also: start_link/6 .","ref":"gen_leader.html#start/6","title":"gen_leader.start/6","type":"function"},{"doc":"Starts a gen_leader process. NameThe locally registered name of the processCandidateNodesThe names of nodes capable of assuming a leadership roleOptArgsOptional arguments given to gen_leader . {workers, Workers} The names of nodes that will be part of the &quot;cluster&quot;, but cannot ever assume a leadership role. Default: []. {vardir, Dir} Directory name used to store candidate's incarnation cookie. Default: &quot;.&quot; {bcast_type, Type} When Type is 'all' each election event (when a new candidate becomes visible to the leader) will be broadcast to all live candidate nodes. Each candidate will get a from_leader/3 callback. When Type is sender , only the newly registered candidate will get the surrendered/3 callback. Default: sender . {heartbeat, Seconds} Heartbeat timeout value used to send ping messages to inactive candidate nodes. ModThe name of the callback moduleArgArgument passed on to Mod:init/1 OptionsSame as gen_server's Options The list of candidates needs to be known from the start. Workers could potentially be added at runtime, but no functionality to do this is provided by this version.","ref":"gen_leader.html#start_link/6","title":"gen_leader.start_link/6","type":"function"},{"doc":"","ref":"gen_leader.html#system_code_change/4","title":"gen_leader.system_code_change/4","type":"function"},{"doc":"","ref":"gen_leader.html#system_continue/3","title":"gen_leader.system_continue/3","type":"function"},{"doc":"","ref":"gen_leader.html#system_terminate/4","title":"gen_leader.system_terminate/4","type":"function"},{"doc":"","ref":"gen_leader.html#worker_announce/2","title":"gen_leader.worker_announce/2","type":"function"},{"doc":"Returns a list of known workers.","ref":"gen_leader.html#workers/1","title":"gen_leader.workers/1","type":"function"},{"doc":"","ref":"gen_leader.html#t:bcast_type/0","title":"gen_leader.bcast_type/0","type":"type"},{"doc":"","ref":"gen_leader.html#t:caller_ref/0","title":"gen_leader.caller_ref/0","type":"type"},{"doc":"","ref":"gen_leader.html#t:elid/0","title":"gen_leader.elid/0","type":"type"},{"doc":"","ref":"gen_leader.html#t:incarn/0","title":"gen_leader.incarn/0","type":"type"},{"doc":"","ref":"gen_leader.html#t:lclock/0","title":"gen_leader.lclock/0","type":"type"},{"doc":"","ref":"gen_leader.html#t:mon_ref/0","title":"gen_leader.mon_ref/0","type":"type"},{"doc":"","ref":"gen_leader.html#t:name/0","title":"gen_leader.name/0","type":"type"},{"doc":"","ref":"gen_leader.html#t:option/0","title":"gen_leader.option/0","type":"type"},{"doc":"","ref":"gen_leader.html#t:options/0","title":"gen_leader.options/0","type":"type"},{"doc":"","ref":"gen_leader.html#t:priority/0","title":"gen_leader.priority/0","type":"type"},{"doc":"","ref":"gen_leader.html#t:server_ref/0","title":"gen_leader.server_ref/0","type":"type"},{"doc":"","ref":"gen_leader.html#t:start_ret/0","title":"gen_leader.start_ret/0","type":"type"},{"doc":"","ref":"gen_leader.html#t:status/0","title":"gen_leader.status/0","type":"type"},{"doc":"Guard in","ref":"gin.html","title":"gin","type":"module"},{"doc":"","ref":"gin.html#parse_transform/2","title":"gin.parse_transform/2","type":"function"},{"doc":"Hexadecimal conversion functions","ref":"hex.html","title":"hex","type":"module"},{"doc":"Convert a hex digit in range [$0..$9,$a..$f,$A..$F] to integer.","ref":"hex.html#dehex/1","title":"hex.dehex/1","type":"function"},{"doc":"Convert an integer to a hex digit in range [0..15].","ref":"hex.html#hex/1","title":"hex.hex/1","type":"function"},{"doc":"Convert a hex string to binary.","ref":"hex.html#to_bin/1","title":"hex.to_bin/1","type":"function"},{"doc":"Convert an iolist to a hex string.","ref":"hex.html#to_hex/1","title":"hex.to_hex/1","type":"function"},{"doc":"Convert a hex string/binary to integer.","ref":"hex.html#to_int/1","title":"hex.to_int/1","type":"function"},{"doc":"","ref":"io_lib_pretty_limited.html","title":"io_lib_pretty_limited","type":"module"},{"doc":"","ref":"io_lib_pretty_limited.html#error_formatter_test/0","title":"io_lib_pretty_limited.error_formatter_test/0","type":"function"},{"doc":"","ref":"io_lib_pretty_limited.html#print/2","title":"io_lib_pretty_limited.print/2","type":"function"},{"doc":"Miscelaneous list functions","ref":"listx.html","title":"listx","type":"module"},{"doc":"Copy every element of tuple TS to tuple TT ignoring the item at Ignore position","ref":"listx.html#copy_tuple_except/5","title":"listx.copy_tuple_except/5","type":"function"},{"doc":"Group elements in the List by element at position Pos .","ref":"listx.html#group/2","title":"listx.group/2","type":"function"},{"doc":"Add every positional element of each tuple in the list. E.g. sum([{1,2}, {3,4}, {5,6}]) -&gt; {9,12}.","ref":"listx.html#sum/1","title":"listx.sum/1","type":"function"},{"doc":"Add every positional element of two tuples. E.g. sum({1,2}, {3,4}) -&gt; {3,6}.","ref":"listx.html#sum/2","title":"listx.sum/2","type":"function"},{"doc":"Convert a record/tuple to a list of {Name,Value} pairs, where Name is a field name taken from the Fields list.","ref":"listx.html#zip_record/2","title":"listx.zip_record/2","type":"function"},{"doc":"OS supporting commands","ref":"osx.html","title":"osx","type":"module"},{"doc":"","ref":"osx.html#command/1","title":"osx.command/1","type":"function"},{"doc":"","ref":"osx.html#command/2","title":"osx.command/2","type":"function"},{"doc":"","ref":"osx.html#command/3","title":"osx.command/3","type":"function"},{"doc":"Return a path where the use of &quot;..&quot; to indicate parent directory has been resolved. Currently does not accept relative paths.","ref":"osx.html#normalpath/1","title":"osx.normalpath/1","type":"function"},{"doc":"Return a canonicalized pathname, having resolved symlinks to their destination. Modelled on realpath(3).","ref":"osx.html#realpath/1","title":"osx.realpath/1","type":"function"},{"doc":"","ref":"osx.html#status/1","title":"osx.status/1","type":"function"},{"doc":"PCAP file reader/writer.","ref":"pcap.html","title":"pcap","type":"module"},{"doc":"","ref":"pcap.html#replay/1","title":"pcap.replay/1","type":"function"},{"doc":"","ref":"pcap.html#replay/2","title":"pcap.replay/2","type":"function"},{"doc":"","ref":"pcap.html#replay/5","title":"pcap.replay/5","type":"function"},{"doc":"","ref":"pcap.html#replay_range/3","title":"pcap.replay_range/3","type":"function"},{"doc":"","ref":"pcap.html#replay_range/4","title":"pcap.replay_range/4","type":"function"},{"doc":"","ref":"pcap.html#write/2","title":"pcap.write/2","type":"function"},{"doc":"Parallel map and multicall.","ref":"pmap.html","title":"pmap","type":"module"},{"doc":"Send messages to pids and wait for replies. Each Pid would get a message in the form: {{FromPid, Ref}, Msg} and would have to reply with: FromPid ! {{self(), Ref}, Reply} . The function aggregates all replies into Success and Error lists. The error list is in the form: {Pid, ErrorReason} .","ref":"pmap.html#multicall/2","title":"pmap.multicall/2","type":"function"},{"doc":"Evaluate the MultiArgs list by calling F on each argument in the list concurrently. See also: pmap/3 .","ref":"pmap.html#pmap/2","title":"pmap.pmap/2","type":"function"},{"doc":"Evaluate the MultiArgs list by calling F on each argument in the list concurrently. Same as pmap/2 but has a Timeout option.","ref":"pmap.html#pmap/3","title":"pmap.pmap/3","type":"function"},{"doc":"Send a reply back to sender.","ref":"pmap.html#reply/2","title":"pmap.reply/2","type":"function"},{"doc":"Profiling functions","ref":"prof.html","title":"prof","type":"module"},{"doc":"Run a function analysis and save it to &quot;fprof-apply.analysis&quot; .","ref":"prof.html#apply/2","title":"prof.apply/2","type":"function"},{"doc":"Run a function analysis and save it to &quot;fprof-apply.analysis&quot; .","ref":"prof.html#apply/3","title":"prof.apply/3","type":"function"},{"doc":"Begin profiling a list of pids","ref":"prof.html#start/1","title":"prof.start/1","type":"function"},{"doc":"Finish profiling a list of pids and save results to a file called &quot;fprof.analysis&quot; .","ref":"prof.html#stop/0","title":"prof.stop/0","type":"function"},{"doc":"Sample restricted remote shell module disabling q/0 and init:stop/{0,1} commands. The shell introduces a replacement command to stop remote node: remote:stop/1 equivalent to init:stop/1 . To activate restricted shell, run the server node like this: erl -sname node@host +Bi -shell restricted_shell restrict_remsh_mod Then you can connect to it with: erl -sname a@myhost -remsh node@host See: http://www.erlang.org/doc/man/shell.html#start_restricted-1","ref":"restrict_remsh_mod.html","title":"restrict_remsh_mod","type":"module"},{"doc":"Replaces init:stop/1 with remote:stop/1 to avoid accidental exit of remote shell.","ref":"restrict_remsh_mod.html#remote_node_stop/1","title":"restrict_remsh_mod.remote_node_stop/1","type":"function"},{"doc":"","ref":"restrict_remsh_mod.html#t:funspec/0","title":"restrict_remsh_mod.funspec/0","type":"type"},{"doc":"Simple Metaprogramming for Erlang","ref":"smerl.html","title":"smerl","type":"module"},{"doc":"Equivalent to add_func(MetaMod, Form, true) . Add a new exported function to MetaMod .","ref":"smerl.html#add_func/2","title":"smerl.add_func/2","type":"function"},{"doc":"Add Function to MetaMod and return the new meta_mod() . If Export is true , add Function to MetaMod 's exports .","ref":"smerl.html#add_func/3","title":"smerl.add_func/3","type":"function"},{"doc":"Equivalent to compile(MetaMod, []) . Compile MetaMod and load the resulting BEAM into the emulator.","ref":"smerl.html#compile/1","title":"smerl.compile/1","type":"function"},{"doc":"Equivalent to compile(MetaMod, [report_errprs, report_warnings, return_errors]) . Compile MetaMod and load the resulting BEAM into the emulator. Options is a list of options as described in the compile module in the Erlang documentation. If an outdir is provided, write the .beam file to it.","ref":"smerl.html#compile/2","title":"smerl.compile/2","type":"function"},{"doc":"Get the curried form for Form with Args . Here, &quot;currying&quot; involves replacing one or more of the function's leading arguments with predefined values.","ref":"smerl.html#curry/2","title":"smerl.curry/2","type":"function"},{"doc":"Curry Module : Function / Arity with the given Args .","ref":"smerl.html#curry/4","title":"smerl.curry/4","type":"function"},{"doc":"Curry Module : Function / Arity with the given Args , renaming it to NewName and return the renamed form.","ref":"smerl.html#curry/5","title":"smerl.curry/5","type":"function"},{"doc":"Add Form curried with Args to MetaMod .","ref":"smerl.html#curry_add/3","title":"smerl.curry_add/3","type":"function"},{"doc":"Add Function / Arity curried with Args to MetaMod .","ref":"smerl.html#curry_add/4","title":"smerl.curry_add/4","type":"function"},{"doc":"Curry MetaMod : Function / Arity and add it to MetaMod as NewName .","ref":"smerl.html#curry_add/5","title":"smerl.curry_add/5","type":"function"},{"doc":"Curry Module : Function / Arity and add it to MetaMod as NewName .","ref":"smerl.html#curry_add/6","title":"smerl.curry_add/6","type":"function"},{"doc":"Replace the function represented by Form in MetaMod with its curried form.","ref":"smerl.html#curry_replace/3","title":"smerl.curry_replace/3","type":"function"},{"doc":"Replace Function / Arity in MetaMod with its curried form.","ref":"smerl.html#curry_replace/4","title":"smerl.curry_replace/4","type":"function"},{"doc":"Apply embed_args/2 with Values to all forms in MetaMod . exports for functions whose arities change are preserved.","ref":"smerl.html#embed_all/2","title":"smerl.embed_all/2","type":"function"},{"doc":"Replace the arguments of the function represented by Form , where the argument's Name matches an element from Vals with the corresponding Value .","ref":"smerl.html#embed_args/2","title":"smerl.embed_args/2","type":"function"},{"doc":"Equivalent to embed_args(MetaMod, Name, Arity, Values, Name) .","ref":"smerl.html#embed_args/4","title":"smerl.embed_args/4","type":"function"},{"doc":"Apply embed_args/2 to MetaMod : Function / Arity and add the resulting function to MetMod , after renaming it to NewName . See also: rename/2 .","ref":"smerl.html#embed_args/5","title":"smerl.embed_args/5","type":"function"},{"doc":"Add aliases for Parent 's functions missing from Child to Child . The new functions in Child are shallow, i.e. they have the name and arity of the corresponding functions in Parent , but instead of implementing their logic they call the Parent functions.","ref":"smerl.html#extend/2","title":"smerl.extend/2","type":"function"},{"doc":"Similar to extend/2 , with the addition of ArityDiff , which indicates the difference in arities Smerl should use when figuring out which functions to generate based on the modules' exports. This is sometimes useful when calling extend/3 followed by embed_all/2 .","ref":"smerl.html#extend/3","title":"smerl.extend/3","type":"function"},{"doc":"","ref":"smerl.html#extend/4","title":"smerl.extend/4","type":"function"},{"doc":"Equivalent to for_file(SrcFilePath, []) .","ref":"smerl.html#for_file/1","title":"smerl.for_file/1","type":"function"},{"doc":"Equivalent to for_file(SrcFilePath, IncludePaths, []) .","ref":"smerl.html#for_file/2","title":"smerl.for_file/2","type":"function"},{"doc":"Create a meta_mod for a module from its source file.","ref":"smerl.html#for_file/3","title":"smerl.for_file/3","type":"function"},{"doc":"Equivalent to for_module(ModuleName, []) .","ref":"smerl.html#for_module/1","title":"smerl.for_module/1","type":"function"},{"doc":"Equivalent to for_module(ModuleName, IncludePaths, []) .","ref":"smerl.html#for_module/2","title":"smerl.for_module/2","type":"function"},{"doc":"Create a meta_mod tuple for an existing module. If ModuleName is a string, it is interpreted as a file name (this is the same as calling for_file/3 ). If ModuleName is an atom, Smerl attempts to find its abstract represtation either from its source file or from its .beam file directly (if it has been compiled with debug_info). If the abstract representation can't be found, this function returns an error. The IncludePaths argument is used when ModuleName is a file name.","ref":"smerl.html#for_module/3","title":"smerl.for_module/3","type":"function"},{"doc":"Get the value of MetaMod 's Key attribute.","ref":"smerl.html#get_attribute/2","title":"smerl.get_attribute/2","type":"function"},{"doc":"Get the export_all value for MetaMod .","ref":"smerl.html#get_export_all/1","title":"smerl.get_export_all/1","type":"function"},{"doc":"Return the list of exports in the meta_mod.","ref":"smerl.html#get_exports/1","title":"smerl.get_exports/1","type":"function"},{"doc":"Return the list of function forms in the meta_mod.","ref":"smerl.html#get_forms/1","title":"smerl.get_forms/1","type":"function"},{"doc":"Attempt to get the func_form() for MetaMod : Function / Arity .","ref":"smerl.html#get_func/3","title":"smerl.get_func/3","type":"function"},{"doc":"Return the module name for the meta_mod.","ref":"smerl.html#get_module/1","title":"smerl.get_module/1","type":"function"},{"doc":"Check whether MetaMod has a function Function / Arity .","ref":"smerl.html#has_func/3","title":"smerl.has_func/3","type":"function"},{"doc":"Create a new meta_mod for a module with the given name.","ref":"smerl.html#new/1","title":"smerl.new/1","type":"function"},{"doc":"Remove an export {Function, Arity} from the list of exports in MetaMod .","ref":"smerl.html#remove_export/3","title":"smerl.remove_export/3","type":"function"},{"doc":"Try to remove Function from MetaMod . If the function exists, return the new meta_mod() . Otherwise, return MetaMod .","ref":"smerl.html#remove_func/3","title":"smerl.remove_func/3","type":"function"},{"doc":"Change the name of the function represented by Form to NewName .","ref":"smerl.html#rename/2","title":"smerl.rename/2","type":"function"},{"doc":"Replace an existing function with a new one. If a matching function doesn't exist, add Function to MetaMod . This is tantamount to calling remove_func/3 followed by add_func/2 .","ref":"smerl.html#replace_func/2","title":"smerl.replace_func/2","type":"function"},{"doc":"Set the export_all value for MetaMod .","ref":"smerl.html#set_export_all/2","title":"smerl.set_export_all/2","type":"function"},{"doc":"Set the MetaMod 's export list to Exports .","ref":"smerl.html#set_exports/2","title":"smerl.set_exports/2","type":"function"},{"doc":"","ref":"smerl.html#set_forms/2","title":"smerl.set_forms/2","type":"function"},{"doc":"Set the meta_mod's module name.","ref":"smerl.html#set_module/2","title":"smerl.set_module/2","type":"function"},{"doc":"Return the pretty-printed source code for MetaMod .","ref":"smerl.html#to_src/1","title":"smerl.to_src/1","type":"function"},{"doc":"Equivalent to file:write_file(Filename, to_src(MetaMod)) .","ref":"smerl.html#to_src/2","title":"smerl.to_src/2","type":"function"},{"doc":"","ref":"smerl.html#t:args/0","title":"smerl.args/0","type":"type"},{"doc":"","ref":"smerl.html#t:error_t/1","title":"smerl.error_t/1","type":"type"},{"doc":"","ref":"smerl.html#t:export/0","title":"smerl.export/0","type":"type"},{"doc":"A list of export() s.","ref":"smerl.html#t:exports/0","title":"smerl.exports/0","type":"type"},{"doc":"The abstract form for the function, as described in the ERTS Users' manual.","ref":"smerl.html#t:func_form/0","title":"smerl.func_form/0","type":"type"},{"doc":"A list of func_form() s.","ref":"smerl.html#t:func_forms/0","title":"smerl.func_forms/0","type":"type"},{"doc":"A data structure holding the abstract representation for a module.","ref":"smerl.html#t:meta_mod/0","title":"smerl.meta_mod/0","type":"type"},{"doc":"","ref":"smerl.html#t:ok_t/1","title":"smerl.ok_t/1","type":"type"},{"doc":"","ref":"smerl.html#t:result/1","title":"smerl.result/1","type":"type"},{"doc":"","ref":"smerl.html#t:result/2","title":"smerl.result/2","type":"type"},{"doc":"SMTP mail client. This module can sent emails to one or more recipients, using primary/backup SMTP servers. Messages can contain attachments. Example : % Send a message to two recipients with a file attachment using % SSL protocol at mail server &quot;mail.bevemyr.com&quot;: smtp : send ( ssl , &quot;Alex &lt;jb@bevemyr.com&gt;&quot; , [ &quot;katrin@bevemyr.com&quot; , &quot;jb@bevemyr.com&quot; ] , &quot;Test Subject&quot; , &quot;My Message&quot; , [ { server , &quot;mail.bevemyr.com&quot; } , { username , &quot;alex&quot; } , { password , &quot;secret&quot; } , { attachments , [ &quot;file1.txt&quot; ] } ] ) . % Send a message to a recipient with a file attachment given custom % MIME type using localhost mail server smtp : send ( tcp , &quot;jb@bevemyr.com&quot; , [ &quot;katrin@bevemyr.com&quot; ] , &quot;Test Subject&quot; , &quot;My Message&quot; , [ { server , &quot;mail.bevemyr.com&quot; } , { username , &quot;alex&quot; } , { password , &quot;secret&quot; } , { attachments , [ { &quot;file1.bin&quot; , &quot;application/custom_MIME&quot; } ] } ] ) . % Send a message to two recipients with an attachment given as list smtp : send ( tcp , &quot;jb@bevemyr.com&quot; , [ &quot;katrin@bevemyr.com&quot; , &quot;jb@bevemyr.com&quot; ] , &quot;Test Subject&quot; , &quot;My Message&quot; , [ { &quot;file1.txt&quot; , &quot;text/plain&quot; , &quot;Attachment past as list&quot; } ] ) .","ref":"smtp.html","title":"smtp","type":"module"},{"doc":"Get domain that this host belongs to.","ref":"smtp.html#domain/0","title":"smtp.domain/0","type":"function"},{"doc":"Send a message to a list of To receipients using localhost . Error is thrown if unable to send a message. Use inet:format_error/1 to decode the Reason if it is an atom.","ref":"smtp.html#send/5","title":"smtp.send/5","type":"function"},{"doc":"Send a message to a list of recipients by connecting to an SMTP server Server. The message can contain attachments in the Attachments list. See examples on the top of this page. Error is thrown if unable to send a message.","ref":"smtp.html#send/6","title":"smtp.send/6","type":"function"},{"doc":"Protocol type.","ref":"smtp.html#t:proto/0","title":"smtp.proto/0","type":"type"},{"doc":"SNMP Options Server - server to connect to (no MX lookup) Relay - domain to do MX lookup of list of servers Port - optional port number (ssl def: 465; tcp def: 25) Auth - controls mandatory / optional authentication Tls - controls enabling of TLS protocol Domain - name of the domain to include in the HELO handshake Timeout - timeout to use (default 10000) Verbose - controls debugging printout Attachments - list of files to attach SSLOpts - additional SSL options if using SSL protocol","ref":"smtp.html#t:smtp_options/0","title":"smtp.smtp_options/0","type":"type"},{"doc":"Implements SNTP query logic. SNTP - Simple Network Time Protocol (RFC-2030).","ref":"sntp.html","title":"sntp","type":"module"},{"doc":"Query NTP time sources from &quot;/etc/ntp.conf&quot; and return min/max/avg offset of current host from given time sources. See also: avg_time/1 .","ref":"sntp.html#avg_time/0","title":"sntp.avg_time/0","type":"function"},{"doc":"Query ServerAddress NTP time sources and return min/max/avg offset of current host from given time sources.","ref":"sntp.html#avg_time/1","title":"sntp.avg_time/1","type":"function"},{"doc":"Query ServerAddress time source to find out server time and current host's offset from time source.","ref":"sntp.html#time/1","title":"sntp.time/1","type":"function"},{"doc":"Return a list of default NTP time servers for this host.","ref":"sntp.html#time_servers/0","title":"sntp.time_servers/0","type":"function"},{"doc":"Return a list of default NTP time servers for this host. If Resolve is true, the list will contain IP addresses or else host names.","ref":"sntp.html#time_servers/1","title":"sntp.time_servers/1","type":"function"},{"doc":"","ref":"ssh_sign.html","title":"ssh_sign","type":"module"},{"doc":"","ref":"ssh_sign.html#public_identity_key/2","title":"ssh_sign.public_identity_key/2","type":"function"},{"doc":"","ref":"ssh_sign.html#sign/1","title":"ssh_sign.sign/1","type":"function"},{"doc":"","ref":"ssh_sign.html#verify/2","title":"ssh_sign.verify/2","type":"function"},{"doc":"","ref":"ssh_tunnel.html","title":"ssh_tunnel","type":"module"},{"doc":"Module for creating SSH tunnels using ssh . https://github.com/drowzy/ssh_tunnel It provides functions to create forwarded ssh channels, similair to how other channels can be created using ssh_connection . There are two type of channels supported * directtcp-ip` - Forwards a port from the client machine to the remote machine. This is the same as `ssh -nNT -L 8080:forward.example.com:9000 user@sshserver.example.com * direct-streamlocal - Forwards to a unix domain socket. This is the same as ssh -nNT -L 8080:/var/lib/mysql/mysql.sock user@sshserver.example.com When using direct_tcpip/3 or direct_stream_local/2 directly there will not be any local port or socket bound, this can either be done using ssh_tunnel or by manually sending data with ssh_connection.send/3 . Although connect/1 can be used to connect to the remote host, other methods are supported. One can use [SSHex](https://github.com/rubencaro/sshex), ssh:connect/3 for instance. ## Tunnels Tunnels are on-demand TCP servers and are bound listeners to either a port or a path. The tunnel will handle relaying TCP messages to the ssh connection and back. ## Examples { ok , SshRef } = ssh_tunnel : connect ( &quot;sshserver.example.com&quot; , 22 , [ ] ) , { ok , Pid } = ssh_tunnel : start_tunnel ( Pid , { tcpip , { 8080 , { &quot;192.168.90.15&quot; , 80 } } } ) , % Send a TCP message for instance HTTP Resp = HTTPoison . get ! ( &quot;127.0.0.1:8080&quot; ) , io : format ( &quot;Received body: ~p \\n&quot; , [ Resp ] )","ref":"ssh_tunnel.html#connect/0","title":"ssh_tunnel.connect/0","type":"function"},{"doc":"Create a connetion to a remote host with the provided options. This function is mostly used as convenience wrapper around ssh_connect/3 and does not support all options. returns: {ok, Connection} or {error, Reason} . https://manpages.debian.org/stretch/erlang-manpages/ssh.3erl.en.html","ref":"ssh_tunnel.html#connect/3","title":"ssh_tunnel.connect/3","type":"function"},{"doc":"Creates a ssh stream local-forward channel to a remote unix domain socket. It sends the request that the server make a connection to its local Unix domain socket. The returned channel together with a ssh connection reference (returned from ssh:connect/4 ) can be used to send messages with ssh_connection:send/3 . returns: {ok, Channel}` or `{error, Reason} . Ex: msg = &quot;GET /images/json HTTP/1.1\\r\\nHost: /var/run/docker.sock\\r\\nAccept: */*\\r\\n\\r\\n&quot; { ok , Pid } = ssh_tunnel : connect ( &quot;192.168.90.15&quot; , 22 ) , { ok , Ch } = ssh_tunnel : direct_stream_local ( Pid , &quot;/var/run/docker.sock&quot; ) , ok = ssh_connection . send ( Pid , Ch , Msg )","ref":"ssh_tunnel.html#direct_stream_local/2","title":"ssh_tunnel.direct_stream_local/2","type":"function"},{"doc":"Creates a ssh directtcp-ip forwarded channel to a remote port. The returned channel together with a ssh connection reference (returned from :ssh.connect/4 ) can be used to send messages with ssh_connection:send/3 returns: {ok, channel} or {error, reason} . ## Examples: msg = &quot;GET / HTTP/1.1\\r\\nHost: localhost:8080\\r\\nUser-Agent: curl/7.47.0\\r\\nAccept: */*\\r\\n\\r\\n&quot; {ok, Pid} = ssh_tunnel:connect(&quot;192.168.1.10&quot;, 22), {ok, Ch} = ssh_tunnel:direct_tcpip(Pid, {&quot;127.0.0.1&quot;, 8080}, {&quot;192.168.1.10&quot;, 80}), ok = ssh_connection:send(Pid, Ch, Msg), recieve do {ssh_cm, _, {data, Channel, _, Data}} -&gt; io:format(&quot;Data: ~p\\n&quot;, [Data]) end","ref":"ssh_tunnel.html#direct_tcpip/3","title":"ssh_tunnel.direct_tcpip/3","type":"function"},{"doc":"","ref":"ssh_tunnel.html#open_channel/6","title":"ssh_tunnel.open_channel/6","type":"function"},{"doc":"Starts a SSHTunnel.Tunnel process. The tunnel will listen to either a local port or local path and handle passing messages between the TCP client and ssh connection. ## Examples {ok, SSH} = ssh_tunnel:connect(&quot;sshserver.example.com&quot;, 22), {ok, Pid} = ssh_tunnel:start_tunnel(Pid, tcp, {8080, {&quot;192.168.90.15&quot;, 80}}) # Send a TCP message %HTTPoison.Response{body: body} = HTTPoison.get!(&quot;127.0.0.1:8080&quot;) IO.puts(&quot;Received body: \#{body})","ref":"ssh_tunnel.html#start_tunnel/3","title":"ssh_tunnel.start_tunnel/3","type":"function"},{"doc":"","ref":"ssh_tunnel.html#t:location/0","title":"ssh_tunnel.location/0","type":"type"},{"doc":"Implements miscelaneous string functions","ref":"stringx.html","title":"stringx","type":"module"},{"doc":"","ref":"stringx.html#align_rows/1","title":"stringx.align_rows/1","type":"function"},{"doc":"Align rows of terms by stringifying them to uniform column width. If some row doesn't need to be aligned, pass its value as a binary. Options can be: Rows is a list. All rows must have the same arity except if a row is a binary. Options contain: {pad, Direction} Column padding direction, where Direction is one of leading , trailing , {Position::integer(), leading|trailing|none} , {last, leading|trailing|none} {return, tuple|list} Return result rows as lists or tuples {prefix, string()} Prefix first item in each row with this string {ignore_empty, boolean()} Don't pad trailing empty columns if this option is true {exclude, [integer()]} Exclude given column numbers","ref":"stringx.html#align_rows/2","title":"stringx.align_rows/2","type":"function"},{"doc":"","ref":"stringx.html#aligned_format/2","title":"stringx.aligned_format/2","type":"function"},{"doc":"","ref":"stringx.html#aligned_format/3","title":"stringx.aligned_format/3","type":"function"},{"doc":"Split a list into batches of N items","ref":"stringx.html#batch_split/2","title":"stringx.batch_split/2","type":"function"},{"doc":"","ref":"stringx.html#binary_join/2","title":"stringx.binary_join/2","type":"function"},{"doc":"Convert format and arguments to binary/list shortening . This function can be used by Elixir, which is missing the equivalent of io_lib.format/2","ref":"stringx.html#format/2","title":"stringx.format/2","type":"function"},{"doc":"Convert format and arguments to binary/list shortening . This function can be used by Elixir, which is missing the equivalent of io_lib.format/2","ref":"stringx.html#format_binary/2","title":"stringx.format_binary/2","type":"function"},{"doc":"","ref":"stringx.html#format_integer/1","title":"stringx.format_integer/1","type":"function"},{"doc":"","ref":"stringx.html#format_integer/2","title":"stringx.format_integer/2","type":"function"},{"doc":"The same as uef_format:format_number/4 with \#{} as the forth argument. See also: format_number/4 .","ref":"stringx.html#format_number/3","title":"stringx.format_number/3","type":"function"},{"doc":"Formats Number by adding thousands separator between each set of 3 digits to the left of the decimal point, substituting Decimals for the decimal point, and rounding to the specified Precision. Returns a binary value.","ref":"stringx.html#format_number/4","title":"stringx.format_number/4","type":"function"},{"doc":"Formats Number in price-like style. Returns a binary containing FormattedPrice formatted with a precision of 2 and decimal digits of 2. The same as format_price/2 with a precision of 2 as the second argument. See uef_format:format_price/2 docs.","ref":"stringx.html#format_price/1","title":"stringx.format_price/1","type":"function"},{"doc":"Formats Number in price-like style. Returns a binary containing FormattedPrice formatted with a specified precision as the second argument and decimal digits of 2. The same as uef_format:format_price/3 with \#{} as the third argument. See also: format_price/3 .","ref":"stringx.html#format_price/2","title":"stringx.format_price/2","type":"function"},{"doc":"Formats Number in price-like style. Returns a binary containing FormattedPrice formatted with a specified precision as the second argument, decimal digits of 2, and with ccy symbol (or options) as the third argument. If CcySymbol_OR_Options is a map the functions works as format_number/4 with decimal digits of 2 as the third argument and with options as the forth one. If CcySymbol_OR_Options is a binary or a string, the corresponding ccy symbol is added to the left.","ref":"stringx.html#format_price/3","title":"stringx.format_price/3","type":"function"},{"doc":"Parse a given CSV file.","ref":"stringx.html#parse_csv/1","title":"stringx.parse_csv/1","type":"function"},{"doc":"Parse a given CSV file.","ref":"stringx.html#parse_csv/2","title":"stringx.parse_csv/2","type":"function"},{"doc":"Pretty print table of lists/tuples/maps to list. The following options control formatting behavior: number_pad Leading padding character used for numbers th_dir Table header row padding direction (both|leading|trailing) td_dir Table row padding direction (both|leading|trailing) td_start Don't print columns less than this (e.g. use 2 for records) td_exclulde List of column ID's (starting with 1) or names to exclude td_sep Column separator (default &quot; | &quot; ) tr_sep Row separator (default &quot;-&quot; ) tr_sep_td Column delimiter used in separating rows ( &quot;+&quot; ) prefix Prepend each row with this string td_formats A tuple containing column formats. Each value is either a format string passed to io_lib:format/2 or a function taking either one argument fun(Value) -&gt; {number|string, FormattedValue::string()} or three arguments fun(Key,Value,Row::tuple()|map()) -&gt; {number|string, FormattedValue::string()} . This three argument function can perform calculation of the field value based on values of other fields in the Row . unicode Use unicode outline characters outline Draw top, left and line box outline (by default only the bottom one is drawn). Values: none - on outline box full - outline box on all 4 sides [top, left, bottom, right] - outline box on given sides Example: 1 &gt; stringx : pretty_print_table ( { a , b , c , d } , [ { a , 10 , ccc } , { bxxx , 200.00123 , &#39;Done&#39; } , { abc , 100.0 , xx } ] , # opts { td_dir = both , td_exclude = [ d ] , td_formats = { undefined , fun ( V ) when is_integer ( V ) -&gt; { number , integer_to_list ( V ) } ; ( V ) when is_float ( V ) -&gt; { number , float_to_list ( V , [ { decimals , 5 } ] ) } end , &quot; ~w &quot; } } ) . a | b | c -- -- - + -- -- -- -- -- - + -- -- -- - a | 10 | ccc bxxx | 200.00123 | &#39;Done&#39; -- -- - + -- -- -- -- -- - + -- -- -- -","ref":"stringx.html#pretty_print_table/1","title":"stringx.pretty_print_table/1","type":"function"},{"doc":"","ref":"stringx.html#pretty_print_table/2","title":"stringx.pretty_print_table/2","type":"function"},{"doc":"","ref":"stringx.html#pretty_print_table/3","title":"stringx.pretty_print_table/3","type":"function"},{"doc":"Pretty print list of maps to list. See also: pretty_table/3 .","ref":"stringx.html#pretty_table/1","title":"stringx.pretty_table/1","type":"function"},{"doc":"Pretty print table of lists/tuples/maps to list. See also: pretty_table/3 .","ref":"stringx.html#pretty_table/2","title":"stringx.pretty_table/2","type":"function"},{"doc":"","ref":"stringx.html#pretty_table/3","title":"stringx.pretty_table/3","type":"function"},{"doc":"Rounds the number to the specified precision.","ref":"stringx.html#round_number/2","title":"stringx.round_number/2","type":"function"},{"doc":"Rounds the number to the precision of 2.","ref":"stringx.html#round_price/1","title":"stringx.round_price/1","type":"function"},{"doc":"Convert words in a string to capitalize first letter of each word.","ref":"stringx.html#titlecase/1","title":"stringx.titlecase/1","type":"function"},{"doc":"Wrap words words in a string","ref":"stringx.html#wordwrap/2","title":"stringx.wordwrap/2","type":"function"},{"doc":"Wrap words words in a string to multiple lines that fit the margin Example: 1&gt; stringx:wordwrap([&quot;abc&quot;, &quot;efg&quot;, &quot;exdf&quot;], 8, &quot;,&quot;). [&quot;abc,efg,&quot;,&quot;exdf&quot;]","ref":"stringx.html#wordwrap/3","title":"stringx.wordwrap/3","type":"function"},{"doc":"","ref":"stringx.html#t:ccy_sym/0","title":"stringx.ccy_sym/0","type":"type"},{"doc":"see types for erlang:float_to_binary/2","ref":"stringx.html#t:decimals/0","title":"stringx.decimals/0","type":"type"},{"doc":"","ref":"stringx.html#t:format_number_opts/0","title":"stringx.format_number_opts/0","type":"type"},{"doc":"","ref":"stringx.html#t:formatted_number/0","title":"stringx.formatted_number/0","type":"type"},{"doc":"","ref":"stringx.html#t:precision/0","title":"stringx.precision/0","type":"type"},{"doc":"","ref":"stringx.html#t:pretty_print_opts/0","title":"stringx.pretty_print_opts/0","type":"type"},{"doc":"","ref":"sup_bridge.html","title":"sup_bridge","type":"behaviour"},{"doc":"","ref":"sup_bridge.html#behaviour_info/1","title":"sup_bridge.behaviour_info/1","type":"function"},{"doc":"","ref":"sup_bridge.html#code_change/3","title":"sup_bridge.code_change/3","type":"function"},{"doc":"","ref":"sup_bridge.html#get_child_pid/1","title":"sup_bridge.get_child_pid/1","type":"function"},{"doc":"","ref":"sup_bridge.html#handle_call/3","title":"sup_bridge.handle_call/3","type":"function"},{"doc":"","ref":"sup_bridge.html#handle_cast/2","title":"sup_bridge.handle_cast/2","type":"function"},{"doc":"","ref":"sup_bridge.html#handle_info/2","title":"sup_bridge.handle_info/2","type":"function"},{"doc":"","ref":"sup_bridge.html#init/1","title":"sup_bridge.init/1","type":"function"},{"doc":"","ref":"sup_bridge.html#start_link/2","title":"sup_bridge.start_link/2","type":"function"},{"doc":"","ref":"sup_bridge.html#start_link/3","title":"sup_bridge.start_link/3","type":"function"},{"doc":"","ref":"sup_bridge.html#terminate/2","title":"sup_bridge.terminate/2","type":"function"},{"doc":"Throttle given rate over a number of seconds. Implementation uses time spacing reservation algorithm where each allocation of samples reserves a fraction of space in the throttling window. The reservation gets freed as the time goes by. No more than the Rate number of samples are allowed to fit in the milliseconds Window . This is an Erlang implementation of the throttling algorithm from the utxx library found at this URL: https://github.com/saleyn/utxx/blob/master/include/utxx/rate_throttler.hpp","ref":"throttle.html","title":"throttle","type":"module"},{"doc":"Add one sample to the throttle","ref":"throttle.html#add/1","title":"throttle.add/1","type":"function"},{"doc":"Add Samples to the throttle","ref":"throttle.html#add/2","title":"throttle.add/2","type":"function"},{"doc":"Add Samples to the throtlle. Return {FitSamples, State} , where FitSamples are the number of samples that fit in the throttling window. 0 means that the throttler is fully congested, and more time needs to elapse before the throttles gets reset to accept more samples.","ref":"throttle.html#add/3","title":"throttle.add/3","type":"function"},{"doc":"See also: available/2 .","ref":"throttle.html#available/1","title":"throttle.available/1","type":"function"},{"doc":"Return the number of available samples given Now current time.","ref":"throttle.html#available/2","title":"throttle.available/2","type":"function"},{"doc":"Call the lambda F, ensuring that it's not called more frequently than the throttle would allow. Example: 1&gt; T = throttle:new(10, 1000). 2&gt; lists:foldl(fun(_,{T1,A}) -&gt; {T2,R} = throttle:call(T1, fun() -&gt; http:get(&quot;google.com&quot;) end), {T2, [R|A]} end, {T,[]}, lists:seq(1, 100)).","ref":"throttle.html#call/2","title":"throttle.call/2","type":"function"},{"doc":"Call the lambda F, ensuring that it's not called more throttle would allow.","ref":"throttle.html#call/3","title":"throttle.call/3","type":"function"},{"doc":"Call M,F,A, ensuring that it's not called more frequently than the throttle would allow. Example: 1&gt; T = throttle:new(10, 1000). 2&gt; lists:foldl(fun(_,{T1,A}) -&gt; {T2,R} = throttle:call(T1, http, get, [&quot;google.com&quot;]), {T2, [R|A]} end, {T,[]}, lists:seq(1, 100)).","ref":"throttle.html#call/4","title":"throttle.call/4","type":"function"},{"doc":"Call M,F,A, ensuring that it's not called more frequently than the throttle would allow.","ref":"throttle.html#call/5","title":"throttle.call/5","type":"function"},{"doc":"See also: curr_rps/2 .","ref":"throttle.html#curr_rps/1","title":"throttle.curr_rps/1","type":"function"},{"doc":"Return currently used rate per second.","ref":"throttle.html#curr_rps/2","title":"throttle.curr_rps/2","type":"function"},{"doc":"Create a new throttle given the Rate per second.","ref":"throttle.html#new/1","title":"throttle.new/1","type":"function"},{"doc":"See also: new/3 .","ref":"throttle.html#new/2","title":"throttle.new/2","type":"function"},{"doc":"Create a new throttle given the Rate per Window milliseconds. Now is expressesed in microseconds since epoch using now() .","ref":"throttle.html#new/3","title":"throttle.new/3","type":"function"},{"doc":"Return the number of milliseconds to wait until the throttling threshold is satisfied to fit another sample.","ref":"throttle.html#next_timeout/1","title":"throttle.next_timeout/1","type":"function"},{"doc":"","ref":"throttle.html#now/0","title":"throttle.now/0","type":"function"},{"doc":"See also: reset/2 .","ref":"throttle.html#reset/1","title":"throttle.reset/1","type":"function"},{"doc":"Reset the throttle request counter","ref":"throttle.html#reset/2","title":"throttle.reset/2","type":"function"},{"doc":"See also: used/2 .","ref":"throttle.html#used/1","title":"throttle.used/1","type":"function"},{"doc":"Return the number of used samples given a_now current time.","ref":"throttle.html#used/2","title":"throttle.used/2","type":"function"},{"doc":"","ref":"throttle.html#t:throttle/0","title":"throttle.throttle/0","type":"type"},{"doc":"","ref":"throttle.html#t:time/0","title":"throttle.time/0","type":"type"},{"doc":"Module to print out terms for logging. Limits by length rather than depth. The resulting string may be slightly larger than the limit; the intention is to provide predictable CPU and memory consumption for formatting terms, not produce precise string lengths. Typical use: trunc_io:print(Term, 500). Source license: Erlang Public License. Original author: Matthias Lang, matthias@corelatus.se","ref":"trunc_io.html","title":"trunc_io","type":"module"},{"doc":"Returns an flattened list containing the ASCII representation of the given term.","ref":"trunc_io.html#fprint/2","title":"trunc_io.fprint/2","type":"function"},{"doc":"","ref":"trunc_io.html#perf1/0","title":"trunc_io.perf1/0","type":"function"},{"doc":"","ref":"trunc_io.html#perf/0","title":"trunc_io.perf/0","type":"function"},{"doc":"","ref":"trunc_io.html#perf/3","title":"trunc_io.perf/3","type":"function"},{"doc":"Returns {List, Length}","ref":"trunc_io.html#print/2","title":"trunc_io.print/2","type":"function"},{"doc":"Same as print, but never crashes. This is a tradeoff. Print might conceivably crash if it's asked to print something it doesn't understand, for example some new data type in a future version of Erlang. If print crashes, we fall back to io_lib to format the term, but then the formatting is depth-limited instead of length limited, so you might run out memory printing it. Out of the frying pan and into the fire.","ref":"trunc_io.html#safe/2","title":"trunc_io.safe/2","type":"function"},{"doc":"","ref":"trunc_io.html#test/0","title":"trunc_io.test/0","type":"function"},{"doc":"","ref":"trunc_io.html#test/2","title":"trunc_io.test/2","type":"function"},{"doc":"This is an extension of the shell commands to do all the work! Either place this file in the path accessible to Erlang (via ERL_LIBS) or add this line to the ~/.erlang file: code:load_abs(os:getenv(&quot;HOME&quot;) ++ &quot;/.erlang/user_default&quot;).","ref":"user_default.html","title":"user_default","type":"module"},{"doc":"","ref":"user_default.html#dbgadd/1","title":"user_default.dbgadd/1","type":"function"},{"doc":"","ref":"user_default.html#dbgadd/2","title":"user_default.dbgadd/2","type":"function"},{"doc":"","ref":"user_default.html#dbgdel/1","title":"user_default.dbgdel/1","type":"function"},{"doc":"","ref":"user_default.html#dbgdel/2","title":"user_default.dbgdel/2","type":"function"},{"doc":"","ref":"user_default.html#dbgoff/0","title":"user_default.dbgoff/0","type":"function"},{"doc":"","ref":"user_default.html#dbgon/1","title":"user_default.dbgon/1","type":"function"},{"doc":"","ref":"user_default.html#dbgon/2","title":"user_default.dbgon/2","type":"function"},{"doc":"","ref":"user_default.html#dbgtc/1","title":"user_default.dbgtc/1","type":"function"},{"doc":"","ref":"user_default.html#debug/0","title":"user_default.debug/0","type":"function"},{"doc":"","ref":"user_default.html#help/0","title":"user_default.help/0","type":"function"},{"doc":"Load all changed modules on all visible nodes","ref":"user_default.html#nl/0","title":"user_default.nl/0","type":"function"},{"doc":"Term printer","ref":"user_default.html#p/1","title":"user_default.p/1","type":"function"},{"doc":"Save command history to file","ref":"user_default.html#saveh/1","title":"user_default.saveh/1","type":"function"},{"doc":"","ref":"user_default.html#tc/2","title":"user_default.tc/2","type":"function"},{"doc":"","ref":"user_default.html#tc/4","title":"user_default.tc/4","type":"function"},{"doc":"Implementation of coloring handler for the Erlang's logger. See https://github.com/hauleth/logger_colorful . Options formatter - parent formatter which will be used for message formatting colors - map of logger:log_level() and colors in form atom describing color name, or 2-ary or 3-ary tuple with 1 or 2 modifiers for the color Available colors: black red green yellow blue magenta cyan white Available modifiers: fg - set foreground color bg - set background color bright - use bright color","ref":"util_log_color_formatter.html","title":"util_log_color_formatter","type":"module"},{"doc":"","ref":"util_log_color_formatter.html#check_config/1","title":"util_log_color_formatter.check_config/1","type":"function"},{"doc":"","ref":"util_log_color_formatter.html#format/2","title":"util_log_color_formatter.format/2","type":"function"},{"doc":"Log formatter Derived from //kernel/logger/logger_formatter This implementation is copied from logger_fomatter.erl and adds the following features: time_offset = none when provided, no time zone offset will be written to the log. time_unit = second | millisecond | microsecond controls time stamp granularity in the log. report_prefix = string() inserts given prefix before msg for logging a report (default: &quot;\\n&quot;). report_term_depth = integer() max depth of terms included in the reports. Use infinity for unlimited (default: 50) Report printing is modified to align keys in a report to the right. Additional template formatting atoms: lev prints &quot;[X]&quot; to the log to indicate the log level, where X` is the first capitalized letter of the log level.&lt;/dd&gt; &lt;dt&gt;LEVEL&lt;/dt&gt;&lt;dd&gt;same as level' but is printed in upper case. modline prints 'Module:Line' to the log. regpid prints: * if the registered name of the caller's pid matches caller's module name. RegisteredName of the calling process X.Y.Z pid of the caller with leading 0. stripped. regname prints &lt;RegisteredName&gt; of the process or its pid if the process is not registered","ref":"util_log_formatter.html","title":"util_log_formatter","type":"module"},{"doc":"","ref":"util_log_formatter.html#check_config/1","title":"util_log_formatter.check_config/1","type":"function"},{"doc":"","ref":"util_log_formatter.html#format/2","title":"util_log_formatter.format/2","type":"function"},{"doc":"","ref":"util_log_formatter.html#t:config/0","title":"util_log_formatter.config/0","type":"type"},{"doc":"","ref":"util_log_formatter.html#t:metakey/0","title":"util_log_formatter.metakey/0","type":"type"},{"doc":"","ref":"util_log_formatter.html#t:template/0","title":"util_log_formatter.template/0","type":"type"},{"doc":"Parse XML into a hierarchical Erlang term % Example xml: &lt; ? xml version = &quot;1.0&quot; encoding = &quot;UTF-8&quot; ? &gt; &lt; root id = &quot;1&quot; &gt; &lt; ele id = &quot;2&quot; / &gt; &lt; ele id = &quot;3&quot; &gt; vvv \\ nxxx \\ n &lt; / ele &gt; &lt; / root &gt; # Usage example 1 &gt; xmltree : file ( L ) . { root , [ { id , &lt;&lt; &quot;1&quot; &gt;&gt; } ] , [ { ele , [ { id , &lt;&lt; &quot;2&quot; &gt;&gt; } ] , [ ] } , { ele , [ { id , &lt;&lt; &quot;3&quot; &gt;&gt; } ] , &lt;&lt; &quot;vvv\\nxxx\\n&quot; &gt;&gt; } ] } 2 &gt; Rules = { root , [ { id , integer } ] , [ { ele , [ { id , integer } ] , string } ] } , 2 &gt; xmltree : string ( L , Rules ) . { root , [ { id , 1 } ] , [ { ele , [ { id , 2 } ] , [ ] } , { ele , [ { id , 3 } ] , &quot;vvv\\nxxx\\n&quot; } ] }","ref":"xmltree.html","title":"xmltree","type":"module"},{"doc":"","ref":"xmltree.html#file/1","title":"xmltree.file/1","type":"function"},{"doc":"","ref":"xmltree.html#file/2","title":"xmltree.file/2","type":"function"},{"doc":"","ref":"xmltree.html#string/1","title":"xmltree.string/1","type":"function"},{"doc":"","ref":"xmltree.html#string/2","title":"xmltree.string/2","type":"function"},{"doc":"","ref":"xmltree.html#xml/1","title":"xmltree.xml/1","type":"function"},{"doc":"","ref":"xmltree.html#xml/2","title":"xmltree.xml/2","type":"function"},{"doc":"","ref":"xref_test.html","title":"xref_test","type":"module"},{"doc":"","ref":"xref_test.html#run/0","title":"xref_test.run/0","type":"function"},{"doc":"","ref":"xref_test.html#run/1","title":"xref_test.run/1","type":"function"},{"doc":"","ref":"xref_test.html#run/2","title":"xref_test.run/2","type":"function"},{"doc":"","ref":"xref_test.html#run_shell/0","title":"xref_test.run_shell/0","type":"function"},{"doc":"Author Serge Aleynikov &lt;serge(at)gmail.com&gt;","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"Add dependency in rebar.config : { deps , [ % ... { util , &quot;~&gt; 1.0&quot; } ] } .","ref":"readme.html#installation","title":"Overview - Installation","type":"extras"},{"doc":"Module Description decompiler decompiles modules and functions (useful for verifying accuracy of code generation) csv CSV parsing and loading data to MySQL env environment variables substitution, path normalization file_log_reader Periodically read an append-only log file and parse newly added data iif Ternery if function including iif/3 , iif/4 , ife/3 , ife/4 parse transforms io_lib_pretty_limited Print term to binary by constraining the output size gin Convenient parse transform for in(Value, [A,B,C]) type of guards hex Hex to bin conversion listx Miscelaneous list handling functions osx Execution of os commands with returned stdout and exit status pcap reader/writer of packet capture files (tcpdump, wireshark) restrict_remsh_mod to be used for remote shells to restrict q() , init:stop() , erlang:halt() , etc. smtp SMTP client supporting tcp and ssl protocols sntp simple SNTP client str stringification functions including str/1 and str/2 parse transforms stringx miscelaneous string functions throttle implements a rate limitting algorithm user_default extending shell with useful debugging and profiling commands build-aux/md-to-edoc.awk AWK script for converting README.md files to overview.edoc Additionally, the following Elixir modules are included: Module File Description CompileTime compile_time.ex Evaluate lambdas at compile time","ref":"readme.html#content","title":"Overview - Content","type":"extras"},{"doc":"See project documentation This project implements an extension of EDoc documentation by using the color scheme similar to GitHub , and generate the overview.edoc from the README.md . In order to use this feature, modify your Makefile to include: - include build - aux / docs - addon . mk build - aux / docs - addon . mk : @echo &quot;Fetching build-aux/docs-addon.mk&quot; &amp;&amp; \\ mkdir - p build - aux &amp;&amp; \\ curl - s - o build - aux / docs - addon . mk https :// raw . githubusercontent . com / saleyn / util / master / build - aux / docs - addon . mk Also in your rebar.config add: { edoc_opts , [ { overview , &quot;build-aux/overview.edoc&quot; } , { stylesheet_file , &quot;build-aux/edoc.css&quot; } , { title , &quot;Project title used by rebar and also inserted as title to the index.html&quot; } , { keywords , &quot;HTML meta keywords (comma-delimited) for search engine crawlers&quot; } , ... ] } . NOTE: the keywords option is not specific to EDoc but used by the HTML reformatting make file docs-addon.mk . This will add the following targets to your Makefile : docs - Make documentation from source code gh-pages - Create GitHub pages for the current project get-version - Show application release version from the *.app.src and rebar.config set-version - Set the version number for the above (make set-version version=X.Y.Z) clean-docs - Remove the generated files in the doc directory","ref":"readme.html#documentation","title":"Overview - Documentation","type":"extras"},{"doc":"To add functions from user_default.erl to Elixir's iex shell, add ~/.iex.exs file containing: import :user_default","ref":"readme.html#elixir","title":"Overview - Elixir","type":"extras"},{"doc":"GitHub","ref":"readme.html#download","title":"Overview - Download","type":"extras"},{"doc":"BSD LICENSE =========== Copyright (C) 2003 Serge Aleynikov &lt;saleyn@gmail.com&gt; All rights reserved. Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met: 1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer. 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution. 3. The names of the authors may not be used to endorse or promote products derived from this software without specific prior written permission. THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL JCRAFT, INC. OR ANY CONTRIBUTORS TO THIS SOFTWARE BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.","ref":"license.html","title":"License","type":"extras"}]